'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var runtimeCore = require('@vue/runtime-core');
var Cookies = require('js-cookie');
var vueComposable = require('vue-composable');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e['default'] : e; }

var Cookies__default = /*#__PURE__*/_interopDefaultLegacy(Cookies);

function useCookie(key, defaultValue, defaultOptions) {
    let cookie = runtimeCore.ref(null);
    let _options;
    let value = Cookies__default.get(key);
    if (vueComposable.isUndefined(value)) {
        cookie.value = defaultValue;
        if (!vueComposable.isUndefined(defaultValue) && !vueComposable.isNull(defaultValue)) {
            Cookies__default.set(key, defaultValue, defaultOptions);
            _options = defaultOptions;
        }
    }
    else {
        cookie.value = value;
    }
    const setCookie = (newValue, options) => {
        cookie.value = newValue;
        _options = options;
        Cookies__default.set(key, cookie.value, _options);
    };
    const removeCookie = () => {
        cookie.value = undefined;
        Cookies__default.remove(key, _options);
    };
    runtimeCore.watch(cookie, (cookie, prevCookie) => {
        if (vueComposable.isUndefined(cookie) || vueComposable.isNull(cookie)) {
            Cookies__default.remove(key, _options);
        }
        else if (cookie !== prevCookie) {
            Cookies__default.set(key, cookie, _options);
        }
    }, {
        deep: true,
    });
    return {
        cookie,
        setCookie,
        removeCookie,
    };
}

exports.useCookie = useCookie;
